unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TPieSeries;
    Series2: TPieSeries;
    procedure Series1BeforeDrawValues(Sender: TObject);
    procedure Series2BeforeDrawValues(Sender: TObject);
  private
    procedure DrawPieSeriesCaption(const aCaption: String; out aTextBottom: integer);
    { Private declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses TeCanvas;

constructor TForm1.Create(AOwner: TComponent);
var
  I: Integer;
  lStr: string;
begin
  inherited;

  for I := 1 to 5 do
  begin
    lStr := 'Item #' + IntToSTr(I);
    if I < 5 then
      Series1.Add(Random(100), lStr);
    Series2.Add(Random(100), lStr);
  end;
end;

const
  H_MARGIN = 10;
  V_MARGIN = 10;

procedure TForm1.Series1BeforeDrawValues(Sender: TObject);
var
  lBtm: Integer;
begin
  Chart1.ChartRect := Rect(H_MARGIN, 1, (Chart1.Width div 2) - H_MARGIN, Chart1.Legend.Top - V_MARGIN);
  DrawPieSeriesCaption(TChartSeries(Sender).Title, lBtm);
  Chart1.ChartRect.Top := lBtm + V_MARGIN;
end;

procedure TForm1.Series2BeforeDrawValues(Sender: TObject);
var
  lBtm: Integer;
begin
  Chart1.ChartRect := Rect((Chart1.Width div 2) + H_MARGIN, 1, Chart1.Width - H_MARGIN, Chart1.Legend.Top - V_MARGIN);
  DrawPieSeriesCaption(TChartSeries(Sender).Title, lBtm);
  Chart1.ChartRect.Top := lBtm + V_MARGIN;
end;

procedure TForm1.DrawPieSeriesCaption(const aCaption: String; out aTextBottom: integer);
var
  lC: TCanvas3D;
  lR: TRect;
  lTextLeft: Integer;
  lTop: Integer;
  lW: integer;
  lWt: Integer;
begin
  lR := Chart1.ChartRect;

  lW := lR.Right-lR.Left;

  lC := Chart1.Canvas;
  lC.Font.Assign(Chart1.Title.Font);
  lWt := lC.TextWidth(aCaption);
  lTop := Chart1.ChartRect.Top + 5;

  lTextLeft := Chart1.ChartRect.Left + (lW div 2) - (lWt div 2);


  lC.TextOut(lTextLeft, lTop, aCaption);


  aTextBottom := lTop + lC.TextHeight('C');

end;

end.


